<* MAIN + *>
<* O2EXTENSIONS + *>

MODULE Main;

IMPORT
  SWholeIO, STextIO, RTS:=oberonRTS, SYS:=SYSTEM;

TYPE
  Row = POINTER TO ARRAY OF LONGREAL;
  Field = POINTER TO ARRAY OF Row;

CONST
  factor = 50;
  LastZ = factor * 235;
  LastR = factor * 114;

PROCEDURE CopyField (source:Field): Field;
  VAR
    iZ,iR:LONGINT;
    res:Field;
  BEGIN
    ASSERT(source#NIL);

    NEW(res,LEN(source^));

    FOR iZ:=0 TO LEN(source^)-1 DO
      NEW(res[iZ],LEN(source^[0]^));
      FOR iR:=0 TO LEN(source^[0]^)-1 DO
        res[iZ,iR]:=source[iZ,iR]
      END;
    END;
    RETURN res;
  END CopyField;

PROCEDURE UsedMemory (): LONGINT;
  VAR
    obj,mem:SYS.CARD32;
  BEGIN
    RTS.GetInfo(obj,mem);
    RETURN mem
  END UsedMemory;

VAR
  f:Field;
  i,iZ,iR:LONGINT;

BEGIN

  NEW(f,LastZ+1);
  FOR iZ:=0 TO LastZ DO
    NEW(f[iZ],LastR+1);
    FOR iR:=0 TO LastR DO
      f[iZ,iR]:=0;
    END;
  END;

  STextIO.WriteLn;
  STextIO.WriteString('factor = ');
  SWholeIO.WriteInt(factor,0);
  STextIO.WriteLn;

  FOR i:=1 TO 10 DO
    RTS.Collect();
    SWholeIO.WriteInt(UsedMemory(),0);
    STextIO.WriteLn;
    f:=CopyField(f);
  END;

END Main.
